/*
 * Copyright (C) 2009 Josh Ventura
 * 
 * This file is part of the Ultimate Doukutsu Trainer.
 * 
 * The trainer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This trainer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this trainer.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


//Editing this will cause more checkboxes to display. As long as you edit them in sync, it will work, though adding too many could cause overlap.
const int weapon_count=11;
char *weapon_name[]={"None","Snake","Polar Star","Fireball","Machine Gun","Missile Launcher","Bubbler","Blade","Super Missile","Nemesis","Spur"};
int weapon_id[]   =  {0x00,  0x01,    0x02,       0x03,      0x04,         0x05,              0x07,     0x09,   0x0A,           0x0C,     0x0D};
bool weapon_queued[weapon_count];

const int item_slot_count=24;
char *item_name[]={
"No item","Arthur's Key","Map System","Santa's Key","Silver Locket","Beast Fang","Life Capsule","ID Card","Jellyfish Juice",
"Rusty Key","Gum Key","Gum Base","Charcoal","Explosive","Puppy","Life Pot","Cure-All","Clinic Key","Booster v0.8","Arms Barrier",
"Turbocharge","Curly's Air Tank","Nikumaru Counter","Booster v2.0","Mimiga Mask -- It can't be worn","Teleporter Room Key",
"Sue's Letter","Controller","Broken Sprinkler","Sprinkler","Tow Rope","Clay Figure Medal","Little Man","Mushroom Badge",
"Ma Pignon","Curly's Underwear","Alien Medal","Chaco's Lipstick","Whimsical Star","Iron Bond"
};

bool infhealth=0,maxhealth=0,infammo=0,neednoammo=0,invincible=0,fixedlevel=0,appendweapon=0,infbooster=0,numpadmove=0;

int desired_level=3;

inline void cheat_init()
{
  for (int i=0; i<weapon_count; i++)
  weapon_queued[i]=0;
}

void update_locks(HWND hwnd,UINT junk1,UINT junk2,DWORD junk3)
{
  int v=255;
  if (maxhealth) WriteProcessMemory(proc,(void*)(0x49E6D0),&v,sizeof(int),NULL); //Health Max
  else if (infhealth) ReadProcessMemory(proc,(void*)(0x49E6D0),&v,sizeof(int),NULL);
  if (infhealth) WriteProcessMemory(proc,(void*)(0x49E6CC),&v,sizeof(int),NULL); //Health Displayed
  if (infhealth) WriteProcessMemory(proc,(void*)(0x49E6D4),&v,sizeof(int),NULL); //Health Current
  if (invincible) WriteProcessMemory(proc,(void*)(0x49E6C8),&v,sizeof(int),NULL); //Invincible (recently hurt)
  
  if (infbooster) 
  {
    ReadProcessMemory(proc,(void*)(0x49E6E8),&v,sizeof(int),NULL);
    if (v<50) { v=255; WriteProcessMemory(proc,(void*)(0x49E6E8),&v,sizeof(int),NULL); } //Booster
  }
  
  int weapon_selected;
  ReadProcessMemory(proc,(void*)(0x499C68),&weapon_selected,sizeof(weapon_selected),NULL);
  
  if (fixedlevel)
  {
    WriteProcessMemory(proc,(void*)(0x499BCC+20*weapon_selected),&desired_level,sizeof(desired_level),NULL); //Level
    if (desired_level==3)
    { ReadProcessMemory(proc,(void*)(0x499BD0+20*weapon_selected),&v,sizeof(v),NULL); if (v>0) v=255; } //Read Experience / Energy
    else v=0;
    WriteProcessMemory(proc,(void*)(0x499BD0+20*weapon_selected),&v,sizeof(v),NULL); //Set Experience / Energy
  }
  v=0;
  if (neednoammo) WriteProcessMemory(proc,(void*)(0x499BD4+20*weapon_selected),&v,sizeof(v),NULL);
  if (infammo)
  {
    ReadProcessMemory(proc,(void*)(0x499BD4+20*weapon_selected),&v,sizeof(v),NULL);
    WriteProcessMemory(proc,(void*)(0x499BD8+20*weapon_selected),&v,sizeof(v),NULL);
  }
  
  //Note that the inventory starts at 0x499B40
  
  SetTimer(hwnd,1,100,(TIMERPROC)update_locks);
}

inline void cycle_weapon(int seekby)
{
  int weapon_selected;
  ReadProcessMemory(proc,(void*)(0x499C68),&weapon_selected,sizeof(weapon_selected),NULL); //Read current weapon slot
  
  int weapon=0,weapon_read;
  ReadProcessMemory(proc,(void*)(0x499BC8+20*weapon_selected),&weapon_read,sizeof(weapon),NULL); //Read the current weapon
  
  //Find the weapon in our list
  for (int i=0;i<weapon_count;i++) 
  if (weapon_id[i]==weapon_read) { weapon=i; break; }
  
  //seek to next queued weapon, or back to start.
  weapon+=seekby; weapon_read=0;
    if (weapon<0) weapon+=weapon_count;
    if (weapon>=weapon_count) weapon-=weapon_count;
  for (int i=0;i<30;i++) 
  {
    if (weapon_queued[weapon]) { weapon_read=1; break; }
    cout << ">> Skipped "<< weapon_name[weapon] <<"\r\n";
    weapon+=seekby; 
      if (weapon<0) weapon+=weapon_count;
      if (weapon>=weapon_count) weapon-=weapon_count;
  }
  
  if (!weapon_read) return; 
  
  cout << "Affirmed " << weapon_name[weapon] << " (" << weapon << ")\r\n";
  weapon=weapon_id[weapon];
  
  WriteProcessMemory(proc,(void*)(0x499BC8+20*weapon_selected),&weapon,sizeof(weapon),NULL);
}

void append_weapon()
{
  for (int i=0;i<5;i++) 
  {
    char *a=(char*)(0x499BC8+(i*20));
    int w=1; ReadProcessMemory(proc,a,&w,sizeof(w),NULL);
    if (w==0)
    {
      w=2;
      WriteProcessMemory(proc,a,&w,sizeof(w),NULL); w=1; a+=4; 
      for (int ii=0;ii<4;ii++) { WriteProcessMemory(proc,a,&w,sizeof(w),NULL); a+=4; w=0; }
      return;
    }
  }
}

int get_inventory(int slot)
{
  int item=0;
  ReadProcessMemory(proc,(void*)(0x499B40 + 4*slot),&item,4,NULL);
  return item;
}

void set_inventory(int slot,int item)
{
  WriteProcessMemory(proc,(void*)(0x499B40 + 4*slot),&item,4,NULL);
}

void move(int xm,int ym)
{
  int x;
  int y;
  if (xm!=0)
  {
    ReadProcessMemory(proc,(void*)(0x49E654),&x,sizeof(x),NULL);
    x+=xm*256;
    WriteProcessMemory(proc,(void*)(0x49E654),&x,sizeof(x),NULL);
  }
  if (ym!=0)
  {
    ReadProcessMemory(proc,(void*)(0x49E658),&y,sizeof(y),NULL);
    y+=ym*256;
    WriteProcessMemory(proc,(void*)(0x49E658),&y,sizeof(y),NULL);
  }
  cout << "Move " << xm << "," << ym << "\r\n";
}
